'''
Created on Apr. 25, 2019

@author: philippe
'''
import gatt
import paho.mqtt.client as paho
import datetime

broker="localhost"
port=1883
def on_publish(client,userdata,result):                     #create function for callback
    print("data published \n")
    pass

manager = gatt.DeviceManager(adapter_name='hci1')
client = paho.Client()
client.username_pw_set(username="kitty",password="kitto")
client.on_publish = on_publish                              #assign function to callback
client.connect(broker,port)                                 #establish connection

class AnyDevice(gatt.Device):
    def connect_succeeded(self):
        super().connect_succeeded()
        print("[%s] Connected" % (self.mac_address))

    def connect_failed(self, error):
        super().connect_failed(error)
        print("[%s] Connection failed: %s" % (self.mac_address, str(error)))

    def disconnect_succeeded(self):
        super().disconnect_succeeded()
        print("[%s] Disconnected" % (self.mac_address))

    def services_resolved(self):
        super().services_resolved()
        fb_service = next(
            s for s in self.services
            if s.uuid == '6e400001-b5a3-f393-e0a9-e50e24dcca9e')
        rx_characteristic = next(
            c for c in fb_service.characteristics
            if c.uuid == '6e400003-b5a3-f393-e0a9-e50e24dcca9e')
        rx_characteristic.enable_notifications()
               
    def descriptor_read_value_failed(self, descriptor, error):
        super().descriptor_read_value_failed(descriptor, error)
        print('descriptor_value_failed')
        print(error)

    def characteristic_enable_notification_succeeded(self, characteristic):
        super().characteristic_enable_notification_succeeded(characteristic)
        print('notifications enabled')

    def characteristic_enable_notification_failed(self, characteristic, error):
        super().characteristic_enable_notification_failed(characteristic, error)
        print('enable notifications failed')
        print(error)

    def characteristic_value_updated(self, characteristic, value):
        super().characteristic_value_updated(characteristic, value)
        msg = value.decode("utf-8")
        print("Data received:", msg)
        if "HEARTBEAT" in msg:
           mqttMessage = "{LastSeen: " + datetime.datetime.today().strftime('%Y-%m-%d-%H:%M:%S') + "}"
           ret= client.publish("FLMS/FB/FBDDEAE86B398D", mqttMessage)      
        if "CARDCHECK" in msg:
           mqttMessage = "{Type: CARDCHECK, Card: " + msg.replace("CARDCHECK:","") + "}"
           ret= client.publish("FLMS/FB/FBDDEAE86B398D/requests/security", mqttMessage)      
    
device = AnyDevice(mac_address='dd:ea:e8:6b:39:8d', manager=manager)
device.connect()

manager.run()
